<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>RevPubkey | Bitcoin one way channel</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="../assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="../assets/js/search.js" data-base="..">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="../index.html" class="title">Bitcoin one way channel</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="../globals.html">Globals</a>
				</li>
				<li>
					<a href="revpubkey.html">RevPubkey</a>
				</li>
			</ul>
			<h1>Class RevPubkey</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<section class="tsd-panel tsd-hierarchy">
				<h3>Hierarchy</h3>
				<ul class="tsd-hierarchy">
					<li>
						<span class="target">RevPubkey</span>
						<ul class="tsd-hierarchy">
							<li>
								<a href="revpubkeyclient.html" class="tsd-signature-type">RevPubkeyClient</a>
							</li>
							<li>
								<a href="revpubkeyprovider.html" class="tsd-signature-type">RevPubkeyProvider</a>
							</li>
						</ul>
					</li>
				</ul>
			</section>
			<section class="tsd-panel-group tsd-index-group">
				<h2>Index</h2>
				<section class="tsd-panel tsd-index-panel">
					<div class="tsd-index-content">
						<section class="tsd-index-section ">
							<h3>Constructors</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-constructor tsd-parent-kind-class"><a href="revpubkey.html#constructor" class="tsd-kind-icon">constructor</a></li>
							</ul>
						</section>
						<section class="tsd-index-section tsd-is-private-protected">
							<h3>Properties</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="revpubkey.html#_blocksinfuture" class="tsd-kind-icon">_blocks<wbr>InFuture</a></li>
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="revpubkey.html#_clientaccpub" class="tsd-kind-icon">_client<wbr>Acc<wbr>Pub</a></li>
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="revpubkey.html#_network" class="tsd-kind-icon">_network</a></li>
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="revpubkey.html#_serveraccpub" class="tsd-kind-icon">_server<wbr>Acc<wbr>Pub</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Methods</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="revpubkey.html#deriveaddress" class="tsd-kind-icon">derive<wbr>Address</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="revpubkey.html#getclientnode" class="tsd-kind-icon">get<wbr>Client<wbr>Node</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="revpubkey.html#getprovidernode" class="tsd-kind-icon">get<wbr>Provider<wbr>Node</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="revpubkey.html#getpubkeys" class="tsd-kind-icon">get<wbr>Pubkeys</a></li>
							</ul>
						</section>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Constructors</h2>
				<section class="tsd-panel tsd-member tsd-kind-constructor tsd-parent-kind-class">
					<a name="constructor" class="tsd-anchor"></a>
					<h3>constructor</h3>
					<ul class="tsd-signatures tsd-kind-constructor tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">new <wbr>Rev<wbr>Pubkey<span class="tsd-signature-symbol">(</span>_clientAccPub<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span>, _serverAccPub<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span>, _network<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span>, _blocksInFuture<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="revpubkey.html" class="tsd-signature-type">RevPubkey</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/kernel/Kernel.ts:215</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>_clientAccPub: <span class="tsd-signature-type">any</span></h5>
								</li>
								<li>
									<h5>_serverAccPub: <span class="tsd-signature-type">any</span></h5>
								</li>
								<li>
									<h5>_network: <span class="tsd-signature-type">any</span></h5>
								</li>
								<li>
									<h5>_blocksInFuture: <span class="tsd-signature-type">any</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="revpubkey.html" class="tsd-signature-type">RevPubkey</a></h4>
						</li>
					</ul>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group tsd-is-private-protected">
				<h2>Properties</h2>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="_blocksinfuture" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> _blocks<wbr>InFuture</h3>
					<div class="tsd-signature tsd-kind-icon">_blocks<wbr>InFuture<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/kernel/Kernel.ts:221</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="_clientaccpub" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> _client<wbr>Acc<wbr>Pub</h3>
					<div class="tsd-signature tsd-kind-icon">_client<wbr>Acc<wbr>Pub<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/kernel/Kernel.ts:218</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="_network" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> _network</h3>
					<div class="tsd-signature tsd-kind-icon">_network<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/kernel/Kernel.ts:220</li>
						</ul>
					</aside>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="_serveraccpub" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> _server<wbr>Acc<wbr>Pub</h3>
					<div class="tsd-signature tsd-kind-icon">_server<wbr>Acc<wbr>Pub<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">any</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in lib/kernel/Kernel.ts:219</li>
						</ul>
					</aside>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Methods</h2>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="deriveaddress" class="tsd-anchor"></a>
					<h3>derive<wbr>Address</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">derive<wbr>Address<span class="tsd-signature-symbol">(</span>i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span>, revHash<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Buffer</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="../interfaces/revpubkey.html" class="tsd-signature-type">RevPubKey</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/kernel/Kernel.ts:234</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Create the custom p2sh called revpubkey contract in the paper. This p2sh
										contains two branch: (i) a revokation hash and a signature, (ii) a timelock
										and a signature. the client has to wait for the timelock before spending
										the money and the provider can take the money if he knows the revokation
									hash.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
									<div class="tsd-comment tsd-typography">
										<div class="lead">
											<p>the index i used to create the revPubKey contract</p>
										</div>
									</div>
								</li>
								<li>
									<h5>revHash: <span class="tsd-signature-type">Buffer</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="../interfaces/revpubkey.html" class="tsd-signature-type">RevPubKey</a></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="getclientnode" class="tsd-anchor"></a>
					<h3>get<wbr>Client<wbr>Node</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Client<wbr>Node<span class="tsd-signature-symbol">(</span>i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/kernel/Kernel.ts:248</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">any</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="getprovidernode" class="tsd-anchor"></a>
					<h3>get<wbr>Provider<wbr>Node</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Provider<wbr>Node<span class="tsd-signature-symbol">(</span>i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/kernel/Kernel.ts:251</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">any</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="getpubkeys" class="tsd-anchor"></a>
					<h3>get<wbr>Pubkeys</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">get<wbr>Pubkeys<span class="tsd-signature-symbol">(</span>i<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="../interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in lib/kernel/Kernel.ts:242</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>i: <span class="tsd-signature-type">number</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="../interfaces/clientproviderpubkeys.html" class="tsd-signature-type">ClientProviderPubkeys</a></h4>
						</li>
					</ul>
				</section>
			</section>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals  ">
						<a href="../globals.html"><em>Globals</em></a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
				</ul>
				<ul class="current">
					<li class="current tsd-kind-class">
						<a href="revpubkey.html" class="tsd-kind-icon">Rev<wbr>Pubkey</a>
						<ul>
							<li class=" tsd-kind-constructor tsd-parent-kind-class">
								<a href="revpubkey.html#constructor" class="tsd-kind-icon">constructor</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="revpubkey.html#_blocksinfuture" class="tsd-kind-icon">_blocks<wbr>InFuture</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="revpubkey.html#_clientaccpub" class="tsd-kind-icon">_client<wbr>Acc<wbr>Pub</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="revpubkey.html#_network" class="tsd-kind-icon">_network</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="revpubkey.html#_serveraccpub" class="tsd-kind-icon">_server<wbr>Acc<wbr>Pub</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="revpubkey.html#deriveaddress" class="tsd-kind-icon">derive<wbr>Address</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="revpubkey.html#getclientnode" class="tsd-kind-icon">get<wbr>Client<wbr>Node</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="revpubkey.html#getprovidernode" class="tsd-kind-icon">get<wbr>Provider<wbr>Node</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="revpubkey.html#getpubkeys" class="tsd-kind-icon">get<wbr>Pubkeys</a>
							</li>
						</ul>
					</li>
				</ul>
				<ul class="after-current">
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-module"><span class="tsd-kind-icon">Module</span></li>
				<li class="tsd-kind-object-literal"><span class="tsd-kind-icon">Object literal</span></li>
				<li class="tsd-kind-variable"><span class="tsd-kind-icon">Variable</span></li>
				<li class="tsd-kind-function"><span class="tsd-kind-icon">Function</span></li>
				<li class="tsd-kind-function tsd-has-type-parameter"><span class="tsd-kind-icon">Function with type parameter</span></li>
				<li class="tsd-kind-index-signature"><span class="tsd-kind-icon">Index signature</span></li>
				<li class="tsd-kind-type-alias"><span class="tsd-kind-icon">Type alias</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-enum"><span class="tsd-kind-icon">Enumeration</span></li>
				<li class="tsd-kind-enum-member"><span class="tsd-kind-icon">Enumeration member</span></li>
				<li class="tsd-kind-property tsd-parent-kind-enum"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-enum"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-interface"><span class="tsd-kind-icon">Interface</span></li>
				<li class="tsd-kind-interface tsd-has-type-parameter"><span class="tsd-kind-icon">Interface with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-interface"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-interface"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-interface"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-class"><span class="tsd-kind-icon">Class</span></li>
				<li class="tsd-kind-class tsd-has-type-parameter"><span class="tsd-kind-icon">Class with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class"><span class="tsd-kind-icon">Accessor</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-class"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static property</span></li>
				<li class="tsd-kind-call-signature tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="http://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="../assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="../assets/js/search.js"><' + '/script>');</script>
</body>
</html>